/**
 * Copyright (c) 2005, Regents of the University of California
 * See the file "license.txt" for details.
 *
 * Created Jan 29, 2006
 */
package vpc.core.decl;

import vpc.core.types.Typeable;

/**
 * The <code>Variable</code> interface is used extensively in the core of the
 * compiler to represent entities that have both a name and a type.
 *
 * @author Ben L. Titzer
 */
public interface Variable extends Typeable {
    /**
     * The <code>getName()</code> method returns the name of this variable as
     * a string.
     *
     * @return a string, unique in the proper scope, that names this variable
     */
    public String getName();

}
